(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/forms'), require('@angular/core'), require('angular-i18next'), require('angular-validation-message')) :
    typeof define === 'function' && define.amd ? define('angular-validation-message-i18next', ['exports', '@angular/forms', '@angular/core', 'angular-i18next', 'angular-validation-message'], factory) :
    (factory((global['angular-validation-message-i18next'] = {}),global.ng.forms,global.ng.core,global.angularI18next,global.angularValidationMessage));
}(this, (function (exports,forms,core,angularI18next,angularValidationMessage) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var I18NextValidationMessageComponent = /** @class */ (function (_super) {
        __extends(I18NextValidationMessageComponent, _super);
        function I18NextValidationMessageComponent(i18nextNamespace, formControlName, formGroupName) {
            var _this = _super.call(this, formControlName, formGroupName) || this;
            _this.i18nextNamespace = i18nextNamespace;
            _this.formControlName = formControlName;
            _this.formGroupName = formGroupName;
            _this.VALIDATION = 'validation';
            return _this;
        }
        Object.defineProperty(I18NextValidationMessageComponent.prototype, "i18nextKey", {
            get: /**
             * @return {?}
             */ function () {
                if (!this.firstMessage.key)
                    return '';
                /** @type {?} */
                var specificKey = [this.VALIDATION, ['control_specific', this.controlPath, this.firstMessage.key].join('.')].join(':');
                /** @type {?} */
                var commonKey = [this.VALIDATION, this.firstMessage.key].join(':');
                /** @type {?} */
                var i18nextKeys = [];
                if (this.i18nextNamespace && this.i18nextNamespace !== this.VALIDATION) {
                    i18nextKeys.push([this.i18nextNamespace, specificKey].join('.'));
                    i18nextKeys.push([this.i18nextNamespace, commonKey].join('.'));
                }
                i18nextKeys.push(specificKey);
                i18nextKeys.push(commonKey);
                return i18nextKeys;
            },
            enumerable: true,
            configurable: true
        });
        I18NextValidationMessageComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'i18next-validation-message',
                        template: "\n      <div class=\"error-container\">{{ i18nextKey | i18nextCap: firstMessage.params }}</div>\n    ",
                        encapsulation: core.ViewEncapsulation.None,
                        styles: ["\n      i18next-validation-message {\n        display: none;\n        width: 100%;\n        position: relative;\n      }\n      i18next-validation-message.standalone,\n      .ng-dirty.ng-invalid + i18next-validation-message {\n        display: block;\n      }\n    "]
                    }] }
        ];
        /** @nocollapse */
        I18NextValidationMessageComponent.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: core.Inject, args: [angularI18next.I18NEXT_NAMESPACE,] }] },
                { type: forms.FormControlName, decorators: [{ type: core.Optional }] },
                { type: forms.FormGroupName, decorators: [{ type: core.Optional }] }
            ];
        };
        return I18NextValidationMessageComponent;
    }(angularValidationMessage.ValidationMessageComponent));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var declarations = [
        I18NextValidationMessageComponent,
    ];
    /** @type {?} */
    var providers = [
        {
            provide: angularValidationMessage.ValidationMessageComponent,
            useValue: I18NextValidationMessageComponent
        }
    ];
    var I18NextValidationMessageModule = /** @class */ (function () {
        function I18NextValidationMessageModule() {
        }
        I18NextValidationMessageModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: declarations,
                        exports: declarations,
                        entryComponents: declarations,
                        imports: [
                            angularI18next.I18NextModule,
                            angularValidationMessage.ValidationMessageModule
                        ],
                        providers: providers
                    },] }
        ];
        return I18NextValidationMessageModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.I18NextValidationMessageComponent = I18NextValidationMessageComponent;
    exports.declarations = declarations;
    exports.providers = providers;
    exports.I18NextValidationMessageModule = I18NextValidationMessageModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=angular-validation-message-i18next.umd.js.map