import { __extends } from 'tslib';
import { FormControlName, FormGroupName } from '@angular/forms';
import { Component, Inject, Optional, ViewEncapsulation, NgModule } from '@angular/core';
import { I18NEXT_NAMESPACE, I18NextModule } from 'angular-i18next';
import { ValidationMessageComponent, ValidationMessageModule } from 'angular-validation-message';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var I18NextValidationMessageComponent = /** @class */ (function (_super) {
    __extends(I18NextValidationMessageComponent, _super);
    function I18NextValidationMessageComponent(i18nextNamespace, formControlName, formGroupName) {
        var _this = _super.call(this, formControlName, formGroupName) || this;
        _this.i18nextNamespace = i18nextNamespace;
        _this.formControlName = formControlName;
        _this.formGroupName = formGroupName;
        _this.VALIDATION = 'validation';
        return _this;
    }
    Object.defineProperty(I18NextValidationMessageComponent.prototype, "i18nextKey", {
        get: /**
         * @return {?}
         */
        function () {
            if (!this.firstMessage.key)
                return '';
            /** @type {?} */
            var specificKey = [this.VALIDATION, ['control_specific', this.controlPath, this.firstMessage.key].join('.')].join(':');
            /** @type {?} */
            var commonKey = [this.VALIDATION, this.firstMessage.key].join(':');
            /** @type {?} */
            var i18nextKeys = [];
            if (this.i18nextNamespace && this.i18nextNamespace !== this.VALIDATION) {
                i18nextKeys.push([this.i18nextNamespace, specificKey].join('.'));
                i18nextKeys.push([this.i18nextNamespace, commonKey].join('.'));
            }
            i18nextKeys.push(specificKey);
            i18nextKeys.push(commonKey);
            return i18nextKeys;
        },
        enumerable: true,
        configurable: true
    });
    I18NextValidationMessageComponent.decorators = [
        { type: Component, args: [{
                    selector: 'i18next-validation-message',
                    template: "\n      <div class=\"error-container\">{{ i18nextKey | i18nextCap: firstMessage.params }}</div>\n    ",
                    encapsulation: ViewEncapsulation.None,
                    styles: ["\n      i18next-validation-message {\n        display: none;\n        width: 100%;\n        position: relative;\n      }\n      i18next-validation-message.standalone,\n      .ng-dirty.ng-invalid + i18next-validation-message {\n        display: block;\n      }\n    "]
                }] }
    ];
    /** @nocollapse */
    I18NextValidationMessageComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [I18NEXT_NAMESPACE,] }] },
        { type: FormControlName, decorators: [{ type: Optional }] },
        { type: FormGroupName, decorators: [{ type: Optional }] }
    ]; };
    return I18NextValidationMessageComponent;
}(ValidationMessageComponent));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var declarations = [
    I18NextValidationMessageComponent,
];
/** @type {?} */
var providers = [
    {
        provide: ValidationMessageComponent,
        useValue: I18NextValidationMessageComponent
    }
];
var I18NextValidationMessageModule = /** @class */ (function () {
    function I18NextValidationMessageModule() {
    }
    I18NextValidationMessageModule.decorators = [
        { type: NgModule, args: [{
                    declarations: declarations,
                    exports: declarations,
                    entryComponents: declarations,
                    imports: [
                        I18NextModule,
                        ValidationMessageModule
                    ],
                    providers: providers
                },] }
    ];
    return I18NextValidationMessageModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { I18NextValidationMessageComponent, declarations, providers, I18NextValidationMessageModule };

//# sourceMappingURL=angular-validation-message-i18next.js.map